<template>
  <div
    v-if="gameEntries.length > 0"
    :class="[
      'grid w-full my-10 grid-cols-2',
      isLiveCasinoEnabled && checkGameEntries
        ? 'gap-x-4 gap-y-6 sm:grid-cols-3 lg:grid-cols-4'
        : 'gap-4',
    ]"
  >
    <div v-for="game in gameEntries" :key="game.GameId">
      <template
        v-if="
          game?.CategoryName.toLowerCase() !== 'live_casino' &&
          // game.GameId !== 73 &&
          game.GameProviderName != 'BBin'
        "
      >
        <div
          v-if="selectedTheme === 'sbo'"
          @click="game.GameId === 74
              ? handleGameEntryOpenWindow(
                  game,
                  1200,
                  850,
                  EnumEntranceLocation.GameLobby
                ) : handleGameSelected(game?.GameId, game.GameProviderShortName, game.EnglishGameName)"
        >
          <sport-horizontal-game-entry :game="game" variant="FLOATING_TAGS" :isShowLabel="providerCount[game.GameProviderName] > 1" />
        </div>
        <nuxt-link
          v-else
          :to="
            authenticated ? `/game/${game?.GameId}${tabTypeForRoute}` : '/login'
          "
        >
          <sport-horizontal-game-entry :game="game" variant="FLOATING_TAGS" :isShowLabel="providerCount[game.GameProviderName] > 1" />
        </nuxt-link>
      </template>

      <div v-else>
        <div
          v-if="authenticated"
          class="cursor-pointer"
          @click="
            game.GameId === 6493
              ? handleGameEntryOpenWindow(
                  game,
                  -1,
                  -1,
                  EnumEntranceLocation.GameLobby
                )
              : handleGameEntryOpenWindow(
                  game,
                  850,
                  850,
                  EnumEntranceLocation.GameLobby
                )
          "
        >
          <sport-vertical-game-entry
            v-if="checkGameEntries"
            :game="game"
            style="--v-game-entry-width: 100%"
            :isShowLabel="providerCount[game.GameProviderName] > 1"
          />
          <sport-horizontal-game-entry
            v-else
            :game="game"
            variant="FLOATING_TAGS"
            :isShowLabel="providerCount[game.GameProviderName] > 1"
          />
        </div>
        <template v-else>
          <div v-if="selectedTheme === 'sbo'" @click="dialog = true">
            <sport-vertical-game-entry
              v-if="gameEntries.length > 10"
              :game="game"
              style="--v-game-entry-width: 100%"
              :isShowLabel="providerCount[game.GameProviderName] > 1"
            />
            <sport-horizontal-game-entry
              v-else
              :game="game"
              variant="FLOATING_TAGS"
              :isShowLabel="providerCount[game.GameProviderName] > 1"
            />
          </div>
          <nuxt-link v-else to="/login">
            <sport-vertical-game-entry
              v-if="checkGameEntries"
              :game="game"
              style="--v-game-entry-width: 100%"
              :isShowLabel="providerCount[game.GameProviderName] > 1"
            />
            <sport-horizontal-game-entry
              v-else
              :game="game"
              variant="FLOATING_TAGS"
              :isShowLabel="providerCount[game.GameProviderName] > 1"
            />
          </nuxt-link>
        </template>
      </div>
    </div>
  </div>
  <lobby-no-game-message v-else />
  <lazy-theme-common-login-dialog v-model="dialog" />
</template>

<script lang="ts">
import { defineComponent, computed, ref } from "vue";
import _ from "lodash";
import { store } from "@/store";
import {
  handleGameEntryOpenWindow,
  useGameEntryBaseOnTabSelected,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";

export default defineComponent({
  name: "GameListEntryComponent",
  setup() {
    const router = useRouter();
    const authenticated = computed(() => store.state.auth);
    const { gameEntrySelected, customizeObjectCasinos } =
      useGameEntryBaseOnTabSelected();
    const tabTypeForRoute = computed(() => {
      let result = "";
      gameEntrySelected.value.forEach((item) => {
        result = item?.TabType.replaceAll(" ", "-").toLowerCase();
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.GameLobby}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.GameLobby}`;
    });
    const selectedTheme = computed((): string => store.state.selectedThemeName);
    const isLiveCasinoEnabled = computed((): boolean =>
      !_.isEmpty(gameEntrySelected.value)
        ? gameEntrySelected.value[0].Category === 2
        : false
    );
    const gameEntries = computed(() => gameEntrySelected.value);
    // const gameEntries = computed(() =>
    //   isLiveCasinoEnabled.value && selectedTheme.value === "black"
    //     ? customizeObjectCasinos.value
    //     : gameEntrySelected.value
    // );
    const dialog = ref(false);
    /**
     * checks if selected theme is SBO
     */
    const handleGameSelected = (GameId: number, Provider = "", EnglishGameName = "") => {
      if (authenticated.value) {
        const trimedEnglishGameName = EnglishGameName.replace(/ /g, "");
        router.push(
          `/game/${GameId}${tabTypeForRoute.value}${
            Provider === "" ? "" : `&provider=${Provider}&englishGameName=${trimedEnglishGameName}`
          }`
        );
      } else {
        dialog.value = true;
      }
    };
    const themeProperties = store.state.companyThemePropertiesFromApi.ThemeProperties;
    const isProviderLiveCasinoType2 = ref(false);
    themeProperties.forEach((property) => {
      if (property.Text === "Provider_type_live_casino_2") {
        isProviderLiveCasinoType2.value = true;
      }
    });
    const { allowCompany } = commonHelper;
    const checkGameEntries = ref(false);
    if (allowCompany.value) {
      checkGameEntries.value = isProviderLiveCasinoType2.value;
    } else {
      checkGameEntries.value = gameEntries.value.length > 10;
    }
    const providerCount = computed(() =>
      textHelper.checkMultiple(gameEntrySelected.value)
    );
    return {
      authenticated,
      gameEntrySelected,
      customizeObjectCasinos,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      tabTypeForRoute,
      selectedTheme,
      gameEntries,
      allowCompany,
      checkGameEntries,
      dialog,
      handleGameSelected,
      isLiveCasinoEnabled,
      isProviderLiveCasinoType2,
      providerCount,
    };
  },
});
</script>

<style scoped lang="scss">
.v-game-entry {
  --v-game-entry-width: 100%;
  --v-game-entry-label-size: 1rem;
  --v-game-entry-floating-bg-translate-y: -2.2rem;

  @media only screen and (min-width: 1024px) {
    & {
      --v-game-entry-floating-bg-scale: calc(1.15);
      --v-game-entry-floating-bg-translate-y: -3rem;
    }
  }
  @media only screen and (min-width: 768px) {
    & {
      --v-game-entry-floating-bg-translate-y: -2.5rem;
    }
  }
}

div[layout="blue_sbo_desktop_3"] {
  & .h-game-entry {
    --h-game-entry-color: var(--background3);
    --h-game-entry-overlay-background: linear-gradient(
      105.79deg,
      rgb(0 0 0 / 10%) 1.39%,
      rgba(0, 0, 0, 0.6) 94.07%
    );
  }

  & .v-game-entry {
    --v-game-entry-color: var(--background3);
  }
}
div[layout="black_flexible_desktop_1"] {
  & .h-game-entry {
    --h-game-entry-color: var(--background5);
  }

  & .v-game-entry {
    --v-game-entry-color: var(--background5);
  }
}
</style>

<style lang="postcss" scoped>
.component-container {
  @apply py-10 grid gap-x-4 gap-y-8;
}
.item-container {
  background: var(--background1);
}
.item-container:hover .item-body-hover {
  @apply opacity-100 ease-in-out duration-500;
}
.item-body {
  @apply w-full h-full flex justify-center;
}
.item-body-hover {
  @apply opacity-0 absolute w-full h-full;
}
.item-body-inner {
  @apply w-full flex items-center justify-center h-full;
  background: rgba(0, 0, 0, 0.5);
}
.item-body-hover-button {
  @apply w-[120px] flex items-center justify-center h-8 bg-green-500 rounded-full;
  @apply font-bold text-white text-sm;
}
.item-footer {
  @apply w-full h-[47px] flex justify-center items-center text-base;
}
</style>
